import { PaginationEdge } from './types';
interface LazyPaginationConnectionOptions<Node = any> {
    getEdgesPromise: () => Promise<PaginationEdge<Node>[]>;
    getCursorCountPromise: () => Promise<number>;
    getTotalCountPromise: () => Promise<number>;
    isBefore: boolean;
}
export default class LazyPaginationConnection<Node = any> {
    #private;
    constructor(options: LazyPaginationConnectionOptions<Node>);
    getEdges(): Promise<PaginationEdge<Node>[]>;
    getTotalCount(): Promise<number>;
    getPageInfo(): Promise<{
        hasNextPage: boolean;
        hasPreviousPage: boolean;
        startCursor: string | null;
        endCursor: string | null;
    }>;
}
export {};
