"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _CachedPromise_promiseGetter, _CachedPromise_cachedPromise, _LazyPaginationConnection_instances, _LazyPaginationConnection_edgesCachedPromise, _LazyPaginationConnection_cursorCountCachedPromise, _LazyPaginationConnection_totalCountCachedPromise, _LazyPaginationConnection_isBefore, _LazyPaginationConnection_getCursorCount;
Object.defineProperty(exports, "__esModule", { value: true });
class CachedPromise {
    constructor(promiseGetter) {
        _CachedPromise_promiseGetter.set(this, void 0);
        _CachedPromise_cachedPromise.set(this, void 0);
        __classPrivateFieldSet(this, _CachedPromise_promiseGetter, promiseGetter, "f");
    }
    get() {
        if (__classPrivateFieldGet(this, _CachedPromise_cachedPromise, "f")) {
            return __classPrivateFieldGet(this, _CachedPromise_cachedPromise, "f");
        }
        __classPrivateFieldSet(this, _CachedPromise_cachedPromise, __classPrivateFieldGet(this, _CachedPromise_promiseGetter, "f").call(this), "f");
        return __classPrivateFieldGet(this, _CachedPromise_cachedPromise, "f");
    }
}
_CachedPromise_promiseGetter = new WeakMap(), _CachedPromise_cachedPromise = new WeakMap();
class LazyPaginationConnection {
    constructor(options) {
        _LazyPaginationConnection_instances.add(this);
        _LazyPaginationConnection_edgesCachedPromise.set(this, void 0);
        _LazyPaginationConnection_cursorCountCachedPromise.set(this, void 0);
        _LazyPaginationConnection_totalCountCachedPromise.set(this, void 0);
        _LazyPaginationConnection_isBefore.set(this, void 0);
        __classPrivateFieldSet(this, _LazyPaginationConnection_edgesCachedPromise, new CachedPromise(options.getEdgesPromise), "f");
        __classPrivateFieldSet(this, _LazyPaginationConnection_cursorCountCachedPromise, new CachedPromise(options.getCursorCountPromise), "f");
        __classPrivateFieldSet(this, _LazyPaginationConnection_totalCountCachedPromise, new CachedPromise(options.getTotalCountPromise), "f");
        __classPrivateFieldSet(this, _LazyPaginationConnection_isBefore, options.isBefore, "f");
    }
    async getEdges() {
        return __classPrivateFieldGet(this, _LazyPaginationConnection_edgesCachedPromise, "f").get();
    }
    async getTotalCount() {
        return __classPrivateFieldGet(this, _LazyPaginationConnection_totalCountCachedPromise, "f").get();
    }
    async getPageInfo() {
        const [edges, totalCount, cursorCount] = await Promise.all([
            this.getEdges(),
            this.getTotalCount(),
            __classPrivateFieldGet(this, _LazyPaginationConnection_instances, "m", _LazyPaginationConnection_getCursorCount).call(this),
        ]);
        const remaining = cursorCount - edges.length;
        const hasNextPage = (!__classPrivateFieldGet(this, _LazyPaginationConnection_isBefore, "f") && remaining > 0) ||
            (__classPrivateFieldGet(this, _LazyPaginationConnection_isBefore, "f") && totalCount - cursorCount > 0);
        const hasPreviousPage = (__classPrivateFieldGet(this, _LazyPaginationConnection_isBefore, "f") && remaining > 0) ||
            (!__classPrivateFieldGet(this, _LazyPaginationConnection_isBefore, "f") && totalCount - cursorCount > 0);
        return {
            hasNextPage,
            hasPreviousPage,
            startCursor: edges.length > 0 ? edges[0].cursor : null,
            endCursor: edges.length > 0 ? edges[edges.length - 1].cursor : null,
        };
    }
}
exports.default = LazyPaginationConnection;
_LazyPaginationConnection_edgesCachedPromise = new WeakMap(), _LazyPaginationConnection_cursorCountCachedPromise = new WeakMap(), _LazyPaginationConnection_totalCountCachedPromise = new WeakMap(), _LazyPaginationConnection_isBefore = new WeakMap(), _LazyPaginationConnection_instances = new WeakSet(), _LazyPaginationConnection_getCursorCount = async function _LazyPaginationConnection_getCursorCount() {
    return __classPrivateFieldGet(this, _LazyPaginationConnection_cursorCountCachedPromise, "f").get();
};
